<?php
//*********************************************
// DESCRIPTION
// Page called from graphs.php to print graphs with time in Y-coordinate
//********************************************
// CREATION :
// 04/08/06 : Cration C. Trussardi
//********************************************


//Inclusions
include("utiles.inc");

$tab_data=unserialize(urldecode($_GET["dataArray"]));

$arguments=array("scope","thisdate","thishour","thismonth");
foreach ($arguments as $argument)
{
	if (getvars($argument))
	{
		$$argument=$_GET[$argument];
	}
	else
	{
		$$argument="";
	}
}//foreach

if ($scope)
{
	switch($scope)
	{
		case "hour":	
			$scale = "By hour today";
			$tab_scale  = array(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23);
		break;
		case "week":
			$scale = "By day this week";
			$tab_scale  = array("Mon","Tue","Wed","Thu","Fri","Sat","Sun");
		break;
		case "month":
			$scale = "By day this month";
			$tab_scale  = array(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31);
		break;
	}//switch
}//fi

if ($thisdate)
{
	if($thishour) {
		$scale = "By minute";
		$tab_scale  = array(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59);
	} else {
		$scale = "By hour";
		$tab_scale  = array(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23);
	}//fi
}//fi

if ($thismonth)
{
	$scale = "By day";
	$tab_scale  = array(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31);
}//fi
	
// Create the graph.
// Graph metadata
if ($thishour)
	{
	$graph = new Graph(950,300,"auto");
}
else {
$graph = new Graph(690,300,"auto");
}
$graph->SetScale("textlin");
$graph->img->SetMargin(60,60,40,60);
$graph->xgrid->Show(true);
$graph->legend->SetLayout(LEGEND_HOR);
$graph->legend->Pos(0.5,0.96,"center","bottom");

if ($thishour)
	{
	$title = " Period : " . date("M-d-Y", mktime(0,0,0,1,$thisdate,date("Y"))) . " - " . $thishour ."h";
}
elseif ($thismonth) {
$title = " Period : This Month";
}
elseif ($scope) {
	switch ($scope) {
		case "hour":
			$title = " Period : By Hour " .date("Y-M-d");
			break;
			
		case "week":
			$title = " Period : By Day This Week";
			break;
		
		case "month":
			$title = " Period : By Day This Month";
			break;
	}
}
else {
$title = " Period : " . date("M-d-Y", mktime(0,0,0,1,$thisdate,date("Y")));
} 
$graph->title->Set($title);
$graph->title->SetFont(FF_FONT1,FS_BOLD);
$graph->xaxis->title->Set($scale);
$graph->xaxis->SetTickLabels($tab_scale);
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->SetColor("blue");

// Create the data plot
$data_plot = new LinePlot($tab_data);
$data_plot->SetColor("blue");
$data_plot->SetWeight(2);
$data_plot->mark->SetType(MARK_FILLEDCIRCLE);
$data_plot->mark->SetColor('blue');
$data_plot->value->HideZero();
$data_plot->value->SetFormat('%u');
$data_plot->value->SetFont(FF_FONT1,FS_BOLD);
$data_plot->value->SetColor('blue');
$data_plot->value->SetMargin(10);
$data_plot->SetLegend("# of selected alerts");
$data_plot->value->Show();

// Add the data plot to the graph
$graph->Add($data_plot);

// Display the graph
$graph->Stroke();
?>