<?php
//**************************************************************
// DESCRIPTION
// Print a graph thanks to different search fields
//**************************************************************
//  CREATION :
// Le 08/04/06 : Cration C. Trussardi
//**************************************************************


//Includes
include("utiles.inc");

//Connect to SGBD
$db = new DB(HOST,USERNAME,PASSWORD,DBNAME);

top();

menu();

echo "\n";

echo "<!-- BEGIN CONTENTS -->\n";
echo "<div id=\"contents\">\n";

echo "<h2><a class=\"anchor\" name=\"top\">Graphs</a></h2>\n";

//The form has been submitted
if (postvars('validation'))
{
	$arguments=array("sensor","sigclass","signature","pre_signature","spade_signature","fulltextop","keyword","ipaddress","direction","directionop","scope","thisdate","thishour","thismonth","severity","protocol","way","order","wport","port");
	
	//Protect arguments against SQL injection
	foreach ($arguments as $argument)
	{
		if (postvars($argument))
		{
			$$argument=quote_smart($_POST[$argument]);
		}
		else
		{
			$$argument="";
		}
	}//foreach

	$graphResults=getGraphResults($sensor,$sigclass,$signature,$pre_signature,$spade_signature,$fulltextop,$keyword,$ipaddress,$direction,$directionop,$port,$wport,$severity,$protocol,$scope,$thisdate,$thishour,$thismonth,$db);
	
	$dataArray=urlencode(serialize($graphResults));	
	
	if ($scope) 
	{
		switch ($scope)
		{
			case quote_smart("hour") :
				echo "<a name=\"graphic\"><img class=\"jpgraph\" src=\"graphic.php?dataArray=".$dataArray."&scope=hour\" alt=\"\"/></a>\n";
			break;
			case quote_smart("week") :
				echo "<a name=\"graphic\"><img class=\"jpgraph\" src=\"graphic.php?dataArray=".$dataArray."&scope=week\" alt=\"\"/></a>\n";
			break;
			case quote_smart("month") :
				echo "<a name=\"graphic\"><img class=\"jpgraph\" src=\"graphic.php?dataArray=".$dataArray."&scope=month\" alt=\"\"/></a>\n";
			break;
		}//switch
	}//fi

	if ($thismonth) 
	{
        echo "<a name=\"graphic\"><img class=\"jpgraph\" src=\"graphic.php?dataArray=".$dataArray."&thismonth=".$thismonth."\" alt=\"\"/></a>\n";
	}//fi
 
	if ($thisdate) 
	{
		if ($thishour) {
		        echo "<a name=\"graphic\"><img class=\"jpgraph\" src=\"graphic.php?dataArray=".$dataArray."&thisdate=".$thisdate."&thishour=".$thishour."\" alt=\"\"/></a>\n";
		} else {
			echo "<a name=\"graphic\"><img class=\"jpgraph\" src=\"graphic.php?dataArray=".$dataArray."&thisdate=".$thisdate."\" alt=\"\"/></a>\n";
		}//fi
	}//fi	

	//Arguments don't need to be protected anymore (easier to print them ...)
	foreach ($arguments as $argument)
	{
		if (postvars($argument))
		{
			$$argument=$_POST[$argument];
		}
		else
		{
			$$argument="";
		}
	}//foreach
	
}//fi

echo "<!-- Begin form -->\n";
echo "<form method=\"post\" action=\"".$_SERVER["PHP_SELF"]."#graphic\">\n";
echo "<table class=\"input\">\n";
echo "<tr>\n";
echo "<td>Sensor :</td>\n";

//Sensor field
echo "<td><select name=\"sensor\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
foreach (getSensorArray("tops",$db) as $getSensor)
{
	(postvars('validation') && ($sensor === $getSensor["sid"])) ? $sensorField="<option selected=\"selected\" value=\"".$getSensor["sid"]."\">" : $sensorField="<option value=\"".$getSensor["sid"]."\">"; echo $sensorField."".$getSensor["hostname"]."</option>\n";
}//foreach
echo "</select></td>\n";

echo "</tr><tr>\n";

//Class field
echo "<td>Class :</td><td><select name=\"class\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
foreach (getClasses($db) as $getClass)
{
	(postvars('validation') && ($sigclass === $getClass["sig_class_id"])) ? $classField="<option selected=\"selected\" value=\"".$getClass["sig_class_id"]."\">" : $classField="<option value=\"".$getClass["sig_class_id"]."\">"; echo $classField."".$getClass["sig_class_name"]."</option>\n";
}//foreach
echo "</select></td>\n";

//Severity field
echo "<td>Severity :</td><td><select name=\"severity\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
(postvars('validation') && ($severity == "3" )) ? $severityField="<option selected=\"selected\" value=\"3\">" : $severityField="<option value=\"3\">"; echo $severityField."Low</option>\n";
(postvars('validation') && ($severity == "2" )) ? $severityField="<option selected=\"selected\" value=\"2\">" : $severityField="<option value=\"3\">"; echo $severityField."Medium</option>\n";
(postvars('validation') && ($severity == "1" )) ? $severityField="<option selected=\"selected\" value=\"1\">" : $severityField="<option value=\"3\">"; echo $severityField."High</option>\n";
echo "</select></td>\n";

echo "</tr></table><table class=\"input\"><tr>\n";

//Rule Signature field
echo "<td>Rule Signature</td><td><select name=\"signature\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
foreach (getSignatures("rule",$db) as $getRuleSignature)
{
	(postvars('validation') && ($signature === $getRuleSignature["sig_name"])) ? $ruleSignatureField="<option selected=\"selected\" value=\"".$getRuleSignature["sig_name"]."\">" : $ruleSignatureField="<option value=\"".$getRuleSignature["sig_name"]."\">"; echo $ruleSignatureField."".$getRuleSignature["sig_name"]."</option>\n";
}//foreach
echo "</select></td>\n";

echo "</tr><tr>\n";

//Preprocessor Signature field
echo "<td>Preprocessor Signature</td><td><select name=\"pre_signature\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
foreach (getSignatures("preprocessor",$db) as $getPreprocessorSignature)
{
	(postvars('validation') && ($pre_signature === $getPreprocessorSignature["sig_name"])) ? $preprocessorSignatureField="<option selected=\"selected\" value=\"".$getPreprocessorSignature["sig_name"]."\">" : $preprocessorSignatureField="<option value=\"".$getPreprocessorSignature["sig_name"]."\">"; echo $preprocessorSignatureField."".$getPreprocessorSignature["sig_name"]."</option>\n";
}//foreach
echo "</select></td>\n";

//Spade Signature field
echo "<td>SPADE alerts</td><td><select name=\"spade_signature\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
foreach (getSignatures("spade",$db) as $getSpadeSignature)
{
	(postvars('validation') && ($spade_signature === $getSpadeSignature["sig_name"])) ? $spadeSignatureField="<option selected=\"selected\" value=\"".$getSpadeSignature["sig_name"]."\">" : $spadeSignatureField="<option value=\"".$getSpadeSignature["sig_name"]."\">"; echo $spadeSignatureField."".$getSpadeSignature["sig_name"]."</option>\n";
}//foreach
echo "</select></td>\n";

echo "</tr><tr>\n";

//Fulltextop field
echo "<td>Full text search in signature</td><td><select name=\"fulltextop\" size=\"1\">\n";
echo "<option value=\"\"></option>\n";
(postvars('validation') && ($fulltextop === "begins" )) ? $fulltextopField="<option selected=\"selected\" value=\"begins\">" : $fulltextopField="<option value=\"begins\">"; echo $fulltextopField."Begins</option>\n";
(postvars('validation') && ($fulltextop === "contains" )) ? $fulltextopField="<option selected=\"selected\" value=\"contains\">" : $fulltextopField="<option value=\"contains\">"; echo $fulltextopField."Contains</option>\n";
(postvars('validation') && ($keyword != "")) ? $keywordField="</select><input type=\"text\" name=\"keyword\" value=\"".str_replace("'","",$keyword)."\" /></td>\n" : $keywordField="</select><input type=\"text\" name=\"keyword\" /></td>\n"; echo $keywordField;
echo "</tr></table><table class=\"input\"><tr>\n";

//Address field
echo "<td>Address</td><td><select name=\"direction\" size=\"1\">\n";
echo "<option value=\"both\">Src or Dst</option>\n";
(postvars('validation') && ($direction === "src" )) ? $directionField="<option selected=\"selected\" value=\"src\">" : $directionField="<option value=\"src\">"; echo $directionField."Source</option>\n";
(postvars('validation') && ($direction === "dst" )) ? $directionField="<option selected=\"selected\" value=\"dst\">" : $directionField="<option value=\"dst\">"; echo $directionField."Dest.</option>\n";
echo "</select></td>\n";

echo "<td><select name=\"directionop\" size=\"1\">\n";
echo "<option selected=\"selected\" value=\"eq\">=</option>\n";
(postvars('validation') && ($directionop === "like" )) ? $directionopField="<option selected=\"selected\" value=\"like\">" : $directionopField="<option value=\"like\">"; echo $directionopField."LIKE</option>\n";
echo "</select></td>\n";

echo "<td><input type=\"text\" name=\"ipaddress\" /></td>\n";

echo "</tr><tr>\n";

//Protocol field
echo "<td>Protocol</td><td><select name=\"protocol\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
(postvars('validation') && ($protocol == "6" )) ? $protocolField="<option selected=\"selected\" value=\"src\">" : $protocolField="<option value=\"6\">"; echo $protocolField."TCP</option>\n";
(postvars('validation') && ($protocol == "17" )) ? $protocolField="<option selected=\"selected\" value=\"dst\">" : $protocolField="<option value=\"17\">"; echo $protocolField."UDP</option>\n";
(postvars('validation') && ($protocol == "1" )) ? $protocolField="<option selected=\"selected\" value=\"src\">" : $protocolField="<option value=\"1\">"; echo $protocolField."ICMP</option>\n";
(postvars('validation') && ($protocol === "other" )) ? $protocolField="<option selected=\"selected\" value=\"dst\">" : $protocolField="<option value=\"other\">"; echo $protocolField."Other</option>\n";
echo "</select></td>\n";

echo "</tr><tr>\n";

//Port field
echo "<td>Port</td><td><select name=\"wport\" size=\"1\">\n";
echo "<option value=\"both\">Src or Dst</option>\n";
(postvars('validation') && ($wport === "src" )) ? $wportField="<option selected=\"selected\" value=\"src\">" : $wportField="<option value=\"src\">"; echo $wportField."Source</option>\n";
(postvars('validation') && ($wport === "dst" )) ? $wportField="<option selected=\"selected\" value=\"dst\">" : $wportField="<option value=\"dst\">"; echo $wportField."Dest.</option>\n";
echo "</select></td>\n";

echo "<td><input type=\"text\" name=\"port\" /></td>\n";

echo "</tr></table><table class=\"input\"><tr>\n";

//HScope field
echo "<td>Graph current time data :</td>\n";
(postvars('validation') && ($scope === "hour")) ? $scopeField="<input checked=\"checked\" type=\"checkbox\" name=\"scope\" value=\"hour\" />" : $scopeField="<input type=\"checkbox\" name=\"scope\" value=\"hour\" />";
echo "<td>".$scopeField." Today</td>\n";
(postvars('validation') && ($scope === "week")) ? $scopeField="<input checked=\"checked\" type=\"checkbox\" name=\"scope\" value=\"week\" />" : $scopeField="<input type=\"checkbox\" name=\"scope\" value=\"week\" />";
echo "<td>".$scopeField." This week</td>\n";
(postvars('validation') && ($scope === "month")) ? $scopeField="<input checked=\"checked\" type=\"checkbox\" name=\"scope\" value=\"month\" />" : $scopeField="<input type=\"checkbox\" name=\"scope\" value=\"month\" />";
echo "<td>".$scopeField." This month</td>\n";

echo "</tr><tr>\n";

//Thisdate field
echo "<td>Or for this date :</td>\n";
echo "<td><select name=\"thisdate\">\n";
echo "<option selected=\"selected\" value=\"\">---</option>\n";
foreach (getDateList("date",$db) as $date)
{
	(postvars('validation') && ($thisdate === $date["dayofyear"])) ? $thisdateField="<option selected=\"selected\" value=\"".$date["dayofyear"]."\">" : $thisdateField="<option value=\"".$date["dayofyear"]."\">";
	echo "".$thisdateField.$date["year"].", ".$date["month"]." ".$date["dayofmonth"]."</option>\n";
}//foreach
echo "</select></td>\n";

//Thishour field
echo "<td>At this hour : </td>\n";
echo "<td><select name=\"thishour\">\n";
echo "<option value=\"\">--</option>\n";
for ($i=0; $i<24; $i++)
{
	(postvars('validation') && ($thishour == "$i")) ? $thishourField="<option selected=\"selected\" value=\"".$i."\">" : $thishourField="<option value=\"".$i."\">";
	echo "".$thishourField.$i."</option>\n";
}//for
echo "</select></td>\n";

echo "</tr><tr>\n";

//Thismonth field
echo "<td>Or for this month :</td>\n";
echo "<td><select name=\"thismonth\">\n";
echo "<option selected=\"selected\" value=\"\">---</option>\n";
foreach (getDateList("month",$db) as $month)
{
	(postvars('validation') && ($thismonth === $month["month"])) ? $thismonthField="<option selected=\"selected\" value=\"".$month["month"]."\">" : $thismonthField="<option value=\"".$month["month"]."\">";
	echo "".$thismonthField.$month["monthname"]."</option>\n";
}//foreach
echo "</select></td></tr>\n";
echo "<tr><td class=\"button\" colspan=\"5\"><input type=\"hidden\" name=\"validation\" value=\"1\" /><input type=\"submit\" value=\"Submit\" /></td></tr>\n";
echo "</table>\n";

echo "</form>\n";
echo "<!--End form -->\n";

echo "</div>\n";
echo "<!--END CONTENTS-->\n";

footer();

?>