<?php
//**************************************************************
// DESCRIPTION
// Print proportional graphs by sensor
//**************************************************************
//  CREATION :
// Le 08/04/06 : Creation C. Trussardi
//**************************************************************


//Includes
include("utiles.inc");

//Connect to SGBD
$db = new DB(HOST,USERNAME,PASSWORD,DBNAME);

$path=URL."/style/images/rrd";

//The form has been submitted
if (postvars('validation'))
{
	$arguments=array("limit","top","sensor","includegraphic","hour","week","mois","thisdate","thishour","thismonth");
	foreach ($arguments as $argument)
	{
		if (postvars($argument))
		{
			$$argument=$_POST[$argument];
		}
		else
		{
			$$argument="";
		}
	}//foreach
}//fi

top();

menu();

echo "\n";

echo "<!-- BEGIN CONTENTS -->\n";
echo "<div id=\"contents\">\n";

echo "<h2><a class=\"anchor\" name=\"top\">Tops</a></h2>\n";

echo "<!-- Begin form -->\n";
echo "<form method=\"post\" action=\"".$_SERVER["PHP_SELF"]."\">\n";
echo "<table class=\"input\">\n";
echo "<tr>\n";
echo "<td>Print the :</td>\n";

//Limit field
echo "<td><select name=\"limit\" size=\"1\">\n";
(postvars('validation') && ($limit === "5")) ? $limitField="<option value=\"5\" selected=\"selected\">" : $limitField="<option value=\"5\">"; echo $limitField."5</option>\n";
(postvars('validation') && ($limit === "10")) ? $limitField="<option value=\"10\" selected=\"selected\">" : $limitField="<option value=\"10\">"; echo $limitField."10</option>\n";
(postvars('validation') && ($limit === "15")) ? $limitField="<option value=\"15\" selected=\"selected\">" : $limitField="<option value=\"15\">"; echo $limitField."15</option>\n";
(postvars('validation') && ($limit === "20")) ? $limitField="<option value=\"20\" selected=\"selected\">" : $limitField="<option value=\"20\">"; echo $limitField."20</option>\n";
echo "</select></td>\n";

//Top field
echo "<td><select name=\"top\" size=\"1\">\n";
(postvars('validation') && ($top === "msalr")) ? $topField="<option value=\"msalr\" selected=\"selected\">" : $topField="<option value=\"msalr\">"; echo $topField."most seen alerts</option>\n";
(postvars('validation') && ($top === "mssrc")) ? $topField="<option value=\"mssrc\" selected=\"selected\">" : $topField="<option value=\"mssrc\">"; echo $topField."most seen sources</option>\n";
(postvars('validation') && ($top === "msdst")) ? $topField="<option value=\"msdst\" selected=\"selected\">" : $topField="<option value=\"msdst\">"; echo $topField."most targeted hosts</option>\n";
echo "</select></td>\n";

//Sensor field
echo "<td><select name=\"sensor\" size=\"1\">\n";
echo "<option selected=\"selected\" value=\"\">Select a sensor</option>\n";
foreach (getSensorArray("tops",$db) as $getSensor)
{
	(postvars('validation') && ($sensor === $getSensor["sid"])) ? $sensorField="<option selected=\"selected\" value=\"".$getSensor["sid"]."\">" : $sensorField="<option value=\"".$getSensor["sid"]."\">"; echo $sensorField."".$getSensor["hostname"]."</option>\n";
}//foreach
echo "</select></td>\n";

// Includegraphic field
(postvars('validation') && ($includegraphic === "yes")) ? $includegraphicField="<input checked=\"checked\" type=\"checkbox\" name=\"includegraphic\" value=\"yes\" />" : $includegraphicField="<input type=\"checkbox\" name=\"includegraphic\" value=\"yes\" />";
echo "<td>Include graphic : ".$includegraphicField."</td>\n";

echo "</tr><tr>\n";

//Hour, Week and Mois fields
echo "<td>Graph current time data :</td>\n";
(postvars('validation') && ($hour === "yes")) ? $hourField="<input checked=\"checked\" type=\"checkbox\" name=\"hour\" value=\"yes\" />" : $hourField="<input type=\"checkbox\" name=\"hour\" value=\"yes\" />";
echo "<td>".$hourField." Today</td>\n";
(postvars('validation') && ($week === "yes")) ? $weekField="<input checked=\"checked\" type=\"checkbox\" name=\"week\" value=\"yes\" />" : $weekField="<input type=\"checkbox\" name=\"week\" value=\"yes\" />";
echo "<td>".$weekField." This week</td>\n";
(postvars('validation') && ($mois === "yes")) ? $monthField="<input checked=\"checked\" type=\"checkbox\" name=\"mois\" value=\"yes\" />" : $monthField="<input type=\"checkbox\" name=\"mois\" value=\"yes\" />";
echo "<td>".$monthField." This month</td>\n";

echo "</tr><tr>\n";

//Thisdate field
echo "<td>Or for this date :</td>\n";
echo "<td><select name=\"thisdate\">\n";
echo "<option selected=\"selected\" value=\"\">---</option>\n";
foreach (getDateList("date",$db) as $date)
{
	(postvars('validation') && ($thisdate === $date["dayofyear"])) ? $thisdateField="<option selected=\"selected\" value=\"".$date["dayofyear"]."\">" : $thisdateField="<option value=\"".$date["dayofyear"]."\">";
	echo "".$thisdateField.$date["year"].", ".$date["month"]." ".$date["dayofmonth"]."</option>\n";
}//foreach
echo "</select></td>\n";

//Thishour field
echo "<td>At this hour : </td>\n";
echo "<td><select name=\"thishour\">\n";
echo "<option value=\"\">--</option>\n";
for ($i=0; $i<24; $i++)
{
	(postvars('validation') && ($thishour == "$i")) ? $thishourField="<option selected=\"selected\" value=\"".$i."\">" : $thishourField="<option value=\"".$i."\">";
	echo "".$thishourField.$i."</option>\n";
}//for
echo "</select></td>\n";

echo "</tr><tr>\n";

//Thismonth field
echo "<td>Or for this month :</td>\n";
echo "<td><select name=\"thismonth\">\n";
echo "<option selected=\"selected\" value=\"\">---</option>\n";
foreach (getDateList("month",$db) as $month)
{
	(postvars('validation') && ($thismonth === $month["month"])) ? $thismonthField="<option selected=\"selected\" value=\"".$month["month"]."\">" : $thismonthField="<option value=\"".$month["month"]."\">";
	echo "".$thismonthField.$month["monthname"]."</option>\n";
}//foreach
echo "</select></td></tr>\n";
echo "<tr><td class=\"button\" colspan=\"5\"><input type=\"hidden\" name=\"validation\" value=\"1\" /><input type=\"submit\" value=\"Submit\" /></td></tr>\n";
echo "</table>\n";

echo "</form>\n";
echo "<!-- End form -->\n";

//The form has been submitted
if (postvars('validation'))
{	
	//Print array with search results
	echo "<table class=\"consultation\">\n";
	echo "<tr>\n";
	switch($top)
	{
		case "msalr" :
			echo "<th>Total</th><th>Signature</th><th>SID</th><th>First detected at</th><th>Last detected at</th>\n";
		break;
		case "mssrc" :
			echo "<th>Total</th><th>Source</th><th>Signature</th><th>First detected at</th><th>Last detected at</th>\n";
		break;
		case "msdst" :
			echo "<th>Total</th><th>Target</th><th>Signature</th><th># of sources</th><th>First detected at</th><th>Last detected at</th>\n";
		break;
	}//switch
	
	echo "</tr>\n";
	
	$i=0;
	
	//Protect arguments against SQL injection
	foreach ($arguments as $argument)
	{
		if (postvars($argument))
		{
			$$argument=quote_smart($_POST[$argument]);
		}
		else
		{
			$$argument="";
		}
	}//foreach
	
	$topResults=getTopResults($sensor,$hour,$week,$mois,$thisdate,$thishour,$thismonth,$limit,$top,$db);
	
	if (count($topResults["data"])>0)
	{
		foreach ($topResults["data"] as $topResult)
		{
			$style=($i ? "dark" : "bright");
			echo "<tr class=\"".$style."\">\n";
			switch($top)
			{
				case "'msalr'" :
					echo "<td>".$topResult["total"]."</td><td>".$topResult["signature"]."</td><td>".$topResult["sid"]."</td><td>".$topResult["min_timestamp"]."</td><td>".$topResult["max_timestamp"]."</td>\n";
				break;
				case "'mssrc'" :
					echo "<td>".$topResult["total"]."</td><td>".$topResult["source"]."</td><td>".$topResult["signature"]."</td><td>".$topResult["min_timestamp"]."</td><td>".$topResult["max_timestamp"]."</td>\n";
				break;
				case "'msdst'" :
					echo "<td>".$topResult["total"]."</td><td>".$topResult["target"]."</td><td>".$topResult["signature"]."</td><td>".$topResult["sources_number"]."</td><td>".$topResult["min_timestamp"]."</td><td>".$topResult["max_timestamp"]."</td>\n";
				break;
			}//switch
			echo "</tr>\n";
			$i = 1 - $i;
		}//foreach
		echo "</table>\n";
	
		//Print graphic if asked
		if ($includegraphic === quote_smart("yes"))
		{
			$dataArray=urlencode(serialize($topResults["data"]));
			echo "<img class=\"jpgraph\" src=\"topGraph.php?dataArray=".$dataArray."&top=".$top."&title=".$topResults["title"]."\" alt=\"\"/>\n";		
		}//fi
	} else {
		//No data
		echo "<p class=\"warning\">No data</p>\n";
	}//fi
}//fi
	
echo "</div>\n";
echo "<!--END CONTENTS-->\n";

footer();

?>